<?php
// FTP Delete By Date - WHMEasyBackup.com
// This sample code is designed to function with our EZ Backup Drive FTP storage
// solution.  Alterations may be needed if used with alternate storage systems. 

$ftp_host = '';
$ftp_port = '';
$ftp_user = '';
$ftp_pass = '';

// In most cases this value should not contain a leading or trailing forward slash ( / ).
// One exception is when backups are stored in a folder outside of the ftp home
// directory.  Typical Example: $ftp_dir = 'backups/daily';
$ftp_dir = '';

// Number of days before backup deletion.  If pruning a folder containing 
// weekly backups be sure to use multiples of 7 (14 to keep two weekly restore 
// points, etc.), and for monthly backups use multiples of 31.
$daysbackup = '7'; 

// No Need To Edit Beyond This Point //

$rawcut = time() - ($daysbackup * 24 * 60 * 60);
$cutdate = date('Ymd', $rawcut);
$cutdate = (int)$cutdate;
$FTPLink = ftp_connect($ftp_host, $ftp_port);
$FTPLogin = ftp_login($FTPLink, $ftp_user, $ftp_pass);
$FTPFiles = ftp_nlist($FTPLink, $ftp_dir);
foreach( $FTPFiles as $key => $value){
	if($value!="." && $value!=".."){
		$filedata = explode("/", $value);
		$filename = end($filedata);
		preg_match('/([1-9]|1[012])[.]([1-9]|[12][0-9]|3[01])[.](20[0-9]+[0-9])/', $filename, $filedate);
		$fileext = substr($filename, -7);
		if(isset($filedate[0]) && $fileext=='.tar.gz')
		{
			$backup_date = $filedate[3];
			if((int)$filedate[1] <= 9)
			{$backup_date .= '0'.$filedate[1];}else{$backup_date .= $filedate[1];}
			if((int)$filedate[2] <= 9)
			{$backup_date .= '0'.$filedate[2];}else{$backup_date .= $filedate[2];}
			$backup_date = (int)$backup_date;
		}
		if(isset($backup_date) && $backup_date <= $cutdate)
		{
			if(ftp_delete($FTPLink, $value))
			{echo date('r').' -- FTP Host = '.$ftp_host.' -- File Delete = '.$value.PHP_EOL;}
		}
		unset($filedate); unset($fileext); if(isset($backup_date)){unset($backup_date);}
	}
}
$FTPClose = ftp_close($FTPLink);
?>